#!/bin/bash
cd "$(dirname "$0")"

clap_dir=$(echo "$CLAP_PATH" | sed 's/:.*//')
clap_dir=${clap_dir:-$HOME/.clap}
vst3_dir="$HOME/.vst3"
bin_dir=${XDG_BIN_HOME:-$HOME/.local/bin}
icon_dir="$HOME/.icons"
desktop_dir="$HOME/.local/share/applications"

set -euo pipefail
chmod +x "./Standalone/Rolling Sampler"
mkdir -p "${bin_dir}/Bird's/Rolling Sampler"
mkdir -p "${vst3_dir}"
mkdir -p "${clap_dir}"
mkdir -p "${icon_dir}"

echo "------------------------------------------------"
full_standalone_path="${bin_dir}/Bird's/Rolling Sampler/Rolling Sampler"
cp -R "./Standalone/Rolling Sampler" "${bin_dir}/Bird's/Rolling Sampler"
echo "Installed Standalone to: ${bin_dir}/Bird's/Rolling Sampler"

full_vst3_path="${vst3_dir}/Rolling Sampler.vst3"
cp -R "./VST3/Rolling Sampler.vst3" "${vst3_dir}"
echo "Installed VST3 to: ${vst3_dir}"

full_clap_path="${clap_dir}/Rolling Sampler.clap"
cp -R "./CLAP/Rolling Sampler.clap" "${clap_dir}"
echo "Installed CLAP plugin to: ${clap_dir}"

full_icon_path="${icon_dir}/rolling-sampler.png"
cp -R "./Resources/rolling-sampler.png" "$icon_dir"
echo "Installed icon to: ${icon_dir}"

full_desktop_path="${desktop_dir}/rolling-sampler.desktop"
cat > "${desktop_dir}/rolling-sampler.desktop" << EOL
[Desktop Entry]
Type=Application
Name=Rolling Sampler
Comment=Rolling Sampler
Categories=Audio;Recorder;
Exec="${bin_dir}/Bird's/Rolling Sampler/Rolling Sampler"
Icon=rolling-sampler
EOL
echo "Created desktop file in: ${desktop_dir}"

cat > "${bin_dir}/Bird's/Rolling Sampler/uninstall.sh" << EOL
#!/bin/bash
cd "$(dirname "$0")"
echo "-------------------------------------"

rm -v "${full_standalone_path}"
rm -v -r "${full_vst3_path}"
rm -v "${full_clap_path}"
rm -v "${full_icon_path}"
rm -v "${full_desktop_path}"

echo "-------------------------------------"
echo "Rolling sampler has been uninstalled."
EOL

echo "------------------------------------------------"
echo "Rolling Sampler has been installed successfully!"
echo "An uninstaller has been created in: ${bin_dir}/Bird's/Rolling Sampler"